*******************************************************************************
*-- File:      		xml2dbfsax2.prg
*-- Time Stamp:		03/02/2011 16:42:08
*-- Author:			Michael Drozdov
*-- E-mail:			Mailto:vfpdev@narod.ru
*-- Home page:		http://vfpdev.narod.ru/
*-- Description:	In this example is shown,
*--						as it is possible use the MsXml2.SAXXMLReader40 object
*--						for convert xml-file with table to dbf-file
*******************************************************************************
*
#DEFINE FILE_DBF			"territories.dbf" 	&&<- as example
#DEFINE FILE_XML			"InpData.xml"
#DEFINE FILE_RESULT			"Result.dbf"
#DEFINE AUTOINC_NEXTVALUE	0 					&&<- set 1 or as need
#DEFINE CRLF				CHR(13) + CHR(10)

CLOSE TABLES ALL
CLOSE DATABASES ALL

SET DEFAULT TO (JUSTPATH(SYS(16)))
IF FILE(FILE_XML)
	ERASE (FILE_XML)
ENDIF
IF FILE(FILE_RESULT)
	ERASE (FILE_RESULT)
ENDIF

LOCAL lcAliasInp as String;
	,lcAliasOut as String

* Get xml-file with table
lcAliasInp = JUSTSTEM(FILE_DBF) 
USE (HOME(2)+ 'northwind\' + FILE_DBF) IN 0 SHARED
CURSORTOXML(lcAliasInp, FILE_XML, 1, 4 + 16 + 512)
COPY STRUCTURE TO (FILE_RESULT)
USE IN (lcAliasInp)
IF FILE(FILE_RESULT)
	lcAliasOut = JUSTSTEM(FILE_RESULT)
	USE (FILE_RESULT) IN 0 EXCLUSIVE 
	IF USED(lcAliasOut)
		LOCAL lbUseAutoinc as Boolean 
		SELECT (lcAliasOut)
		IF CURSORGETPROP("AutoIncError", lcAliasOut)
			CURSORSETPROP("AutoIncError", .F., lcAliasOut)
			lbUseAutoinc = .T.
		ENDIF
		LOCAL ARRAY laFields[1,1]
		LOCAL lnField as Integer;
			,lcField as String;
			,lnNext as Integer;
			,lnStep as Integer 
		FOR lnField = 1 TO AFIELDS(laFields, lcAliasOut)
			IF laFields[lnField, 2] = "I"
				lcField = laFields[lnField, 1]
				lnNext = laFields[lnField, 17]
				IF lnNext <> 0
					IF AUTOINC_NEXTVALUE <> 0 
						IF LENC(lcField) > 10
							lcField = LEFTC(lcField, 10)
						ENDIF
						lnStep = laFields[lnField, 18]
						ALTER TABLE (lcAliasOut) ALTER COLUMN (lcField) I AUTOINC NEXTVALUE AUTOINC_NEXTVALUE STEP (lnStep)
					ENDIF
					lbUseAutoinc = .T.
				ENDIF
			ENDIF
		ENDFOR
		IF lbUseAutoinc
			SET AUTOINCERROR OFF
		ENDIF
	ELSE
		RETURN .F.
	ENDIF		
ELSE
	RETURN .F.
ENDIF

* Convert xml-file with table to dbf-file
SET DATE YMD 
SET CENTURY ON 
SET MARK TO "-"
SET POINT TO "."

LOCAL loSAXXMLReader as MsXml2.SAXXMLReader40;
	,loContentHandlerImpl as ContentHandlerImpl;
	,loException as Exception
TRY
	loContentHandlerImpl = CREATEOBJECT("ContentHandlerImpl")
	loSAXXMLReader = CREATEOBJECT("MsXml2.SAXXMLReader.4.0")
	loSAXXMLReader.contentHandler = loContentHandlerImpl
	loSAXXMLReader.errorHandler = loContentHandlerImpl
	loSAXXMLReader.parseURL(FILE_XML)
CATCH TO loException
	MESSAGEBOX("Error: " + TRANSFORM(loException.ErrorNo)+ CRLF;
		+ "Message: " + loException.Message;
		+ IIF(!EMPTY(loException.Procedure), CRLF + "Procedure: " + loException.Procedure, ""), 16, _SCREEN.Caption)
FINALLY
	loContentHandlerImpl = NULL
	loSAXXMLReader = NULL
	SET SYSFORMATS ON   
ENDTRY
IF !EMPTY(lcAliasOut) AND USED(lcAliasOut)
	SELECT (lcAliasOut)
	GO TOP 
	BROWSE NORMAL LAST NOWAIT
ENDIF
 
DEFINE CLASS ContentHandlerImpl AS session
	contentHandler = NULL
	errorHandler = NULL
	errorHappen = .F.
	PROTECTED simpStack
	PROTECTED typesHelper
	simpStack = NULL
	typesHelper = NULL

	IMPLEMENTS IVBSAXContentHandler EXCLUDE IN "msxml4.dll"
	IMPLEMENTS IVBSAXErrorHandler EXCLUDE IN "msxml4.dll"

	PROCEDURE Destroy
		this.contentHandler = NULL
		this.errorHandler = NULL
		this.simpStack = NULL
		this.typesHelper = NULL
	ENDPROC

	PROCEDURE Init
	ENDPROC

	PROTECTED PROCEDURE Initialize
		this.errorHappen = .F.
		this.simpStack = CREATEOBJECT("simpStack")
		this.typesHelper = CREATEOBJECT("typesHelper")
		this.typesHelper.Initialize()
	ENDPROC

	*////////////////////////////////////
	*// IMPLEMENTS IVBSAXContentHandler
	*//
	PROCEDURE IVBSAXContentHandler_put_documentLocator(RHS As VARIANT) AS VARIANT;
			HELPSTRING "Receive an object for locating the origin of SAX document events."
		this.Initialize()
	ENDPROC

	PROCEDURE IVBSAXContentHandler_startDocument() AS VOID;
			HELPSTRING "Receive notification of the beginning of a document."
		* add user code here
	ENDPROC

	PROCEDURE IVBSAXContentHandler_endDocument() AS VOID;
			HELPSTRING "Receive notification of the end of a document."
		* add user code here
	ENDPROC

	PROCEDURE IVBSAXContentHandler_startPrefixMapping(strPrefix AS STRING @, strURI AS STRING @) AS VOID;
			HELPSTRING "Begin the scope of a prefix-URI Namespace mapping."
		* add user code here
	ENDPROC

	PROCEDURE IVBSAXContentHandler_endPrefixMapping(strPrefix AS STRING @) AS VOID;
			HELPSTRING "End the scope of a prefix-URI mapping."
		* add user code here
	ENDPROC

	PROCEDURE IVBSAXContentHandler_startElement(strNamespaceURI AS STRING @, strLocalName AS STRING @;
		,strQName AS STRING @, oAttributes AS VARIANT) AS VOID;
			HELPSTRING "Receive notification of the beginning of an element."
		IF this.simpStack.Size() = 1
			* Insert new row
			LOCAL lnOldDs as Integer
			lnOldDs = SET("Datasession")
			SET DATASESSION TO
			IF !EMPTY(ALIAS())
				APPEND BLANK
			ENDIF
			SET DATASESSION TO lnOldDs
		ENDIF
		this.simpStack.Push(strLocalName)
	ENDPROC

	PROCEDURE IVBSAXContentHandler_endElement(strNamespaceURI AS STRING @, strLocalName AS STRING @;
		,strQName AS STRING @) AS VOID;
			HELPSTRING "Receive notification of the end of an element."
		this.simpStack.Pop()
	ENDPROC

	PROCEDURE IVBSAXContentHandler_characters(strChars AS STRING @) AS VOID;
			HELPSTRING "Receive notification of character data."
		LOCAL lcVal as String
		lcVal = TRIM(strChars)
		IF LENC(lcVal) > 0 ;
				AND (ISALPHA(lcVal) OR ISDIGIT(lcVal));
				AND !this.simpStack.Empty()
			* Update field value in current row
			LOCAL lcField as String, lcType as String, luValue
			lcField = this.simpStack.Top() && Get filed name
			IF LENC(lcField) > 10
				lcField = LEFTC(lcField, 10)
			ENDIF
			* Get field type
			lcType = this.typesHelper.GetFieldType(lcField)
			IF !EMPTY(lcType)
				* Get field value as lcType
				luValue = this.typesHelper.GetFieldValue(lcType, lcVal)
				LOCAL lnOldDs as Integer
				lnOldDs = SET("Datasession")
				SET DATASESSION TO
				IF !EMPTY(ALIAS()) AND !EMPTY(lcType)
					* Update field value in current row
					REPLACE (lcField) WITH luValue
				ENDIF
			ENDIF
			SET DATASESSION TO lnOldDs
		ENDIF
	ENDPROC

	PROCEDURE IVBSAXContentHandler_ignorableWhitespace(strChars AS STRING @) AS VOID;
			HELPSTRING "Receive notification of ignorable whitespace in element content."
		* add user code here
	ENDPROC

	PROCEDURE IVBSAXContentHandler_processingInstruction(strTarget AS STRING @, strData AS STRING @) AS VOID;
			HELPSTRING "Receive notification of a processing instruction."
		* add user code here
	ENDPROC

	PROCEDURE IVBSAXContentHandler_skippedEntity(strName AS STRING @) AS VOID;
			HELPSTRING "Receive notification of a skipped entity."
		* add user code here
	ENDPROC

	*////////////////////////////////////
	*// IMPLEMENTS IVBSAXErrorHandler
	*//
	PROCEDURE IVBSAXErrorHandler_error(oLocator AS VARIANT, strErrorMessage AS STRING @;
		,nErrorCode AS Number) AS VOID;
			HELPSTRING "Receive notification of a recoverable error."
		* add user code here
	ENDPROC

	PROCEDURE IVBSAXErrorHandler_fatalError(oLocator AS VARIANT, strErrorMessage AS STRING @;
		,nErrorCode AS Number) AS VOID;
			HELPSTRING "Receive notification of a non-recoverable error."
		* add user code here
	ENDPROC

	PROCEDURE IVBSAXErrorHandler_ignorableWarning(oLocator AS VARIANT, strErrorMessage AS STRING @;
		,nErrorCode AS Number) AS VOID;
			HELPSTRING "Receive notification of an ignorable warning."
		* add user code here
	ENDPROC

ENDDEFINE

DEFINE CLASS typesHelper AS session
	DIMENSION arrFields[1,1]
	PROTECTED lenFields

	PROCEDURE Initialize() as VOID 
		LOCAL lnOldDs as Integer
		lnOldDs = SET("Datasession")
		SET DATASESSION TO
		IF !EMPTY(ALIAS())
			* Initialize array this.arrFields
			this.lenFields = AFIELDS(this.arrFields)
		ELSE
			DIMENSION this.arrFileds[1,1]
			this.arrFields = ""
			this.lenFields = 0
		ENDIF
		SET DATASESSION TO lnOldDs
	ENDPROC

	* Get field type
	FUNCTION GetFieldType(tcField as String) as String
		IF !EMPTY(tcField)
			LOCAL lnItem as Integer
			lnItem = ASCAN(this.arrFields, UPPER(tcField), 1, this.lenFields, 1, 1+8)
			IF lnItem <> 0
				RETURN this.arrFields[lnItem, 2] ; 
					+ "," + TRANSFORM(this.arrFields[lnItem, 3]) ;
					+ "," + TRANSFORM(this.arrFields[lnItem, 4])
			ENDIF
		ENDIF
		RETURN ""
	ENDFUNC

	* Convert value from tcValue as String to tcType as String
	FUNCTION GetFieldValue(tcType as String, tcValue as String)
		LOCAL luValue
		IF !EMPTY(tcType)
			* Reset datasession
			LOCAL lnOldDs as Integer
			lnOldDs = SET("Datasession")
			SET DATASESSION TO
			* Get file type
			LOCAL lcFldType as String
			lcFldType = GETWORDNUM(tcType, 1, ",") 
			* Get value for field
			DO CASE
			CASE lcFldType = "C"
				luValue = tcValue
			CASE lcFldType = "I"
				luValue = INT(VAL(tcValue))
			CASE INLIST(lcFldType, "N", "F", "B", "Y")
				LOCAL lnFldWidth as Integer;
					,lnFldDecimalPlaces as Integer;
					,lnOldDP as Integer  
				*lnFldWidth = INT(VAL(GETWORDNUM(tcType, 2, ",")))
				lnFldDecimalPlaces = INT(VAL(GETWORDNUM(tcType, 3, ",")))
				lnOldDP = SET("Decimals") 
				SET DECIMALS TO lnFldDecimalPlaces 
				luValue = VAL(tcValue)
				SET DECIMALS TO lnOldDP
			CASE lcFldType = "D"
				luValue = CTOD(tcValue)
			CASE lcFldType = "T"
				luValue = CTOT(tcValue)
			CASE lcFldType = "L"
				luValue = IIF(UPPER(tcValue) = "TRUE", .T., .F.)
				*<-- Inset your code here to support other types 
			OTHERWISE
				* -- Error type
				SET DATASESSION TO lnOldDs
				ERROR 2201, "Cannot determine data type of the expression '" + tcValue + "' as type '" + tcType + "'"
			ENDCASE
			* Restore datasession
			SET DATASESSION TO lnOldDs
		ENDIF
		RETURN luValue
	ENDFUNC
	
ENDDEFINE

DEFINE CLASS simpStack AS session
	PROTECTED stackValue
	PROTECTED stackSep

	* Init props
	PROCEDURE Init()
		this.stackValue = ""
		this.stackSep = ","
	ENDFUNC

	* Tests if the stack is empty.
	FUNCTION Empty() AS Boolean
		RETURN (LENC(this.stackValue) = 0)
	ENDFUNC

	* Removes the element from the top of the stack.
	FUNCTION Pop() AS VOID
		IF !this.Empty()
			LOCAL lnPos as Integer
			lnPos = ATC(this.stackSep, this.stackValue)
			IF lnPos > 0
				this.stackValue = SUBSTRC(this.stackValue, lnPos + 1)
			ELSE
				this.stackValue = ""
			ENDIF
		ENDIF
	ENDFUNC

	* Adds an element to the top of the stack.
	FUNCTION Push(tcValue as String) AS VOID
		IF !this.Empty()
			this.stackValue = tcValue + this.stackSep + this.stackValue
		ELSE
			this.stackValue = tcValue
		ENDIF
	ENDFUNC

	* Returns the number of elements in the stack.
	FUNCTION Size() AS Integer
		IF !this.Empty()
			RETURN GETWORDCOUNT(this.stackValue, this.stackSep)
		ENDIF
		RETURN 0
	ENDFUNC

	* Returns a reference to an element at the top of the stack.
	FUNCTION Top() AS String
		IF !this.Empty()
			RETURN GETWORDNUM(this.stackValue, 1, this.stackSep)
		ENDIF
		RETURN ""
	ENDFUNC

ENDDEFINE
